'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.navItemShapeDefaults = exports.navItemShape = undefined;

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var navItemShape = exports.navItemShape = {
  /**
   * Text to be displayed in profile link.
   */
  text: _propTypes2.default.string.isRequired,
  /**
   * The path the link would redirect to.
   */
  url: _propTypes2.default.string,
  /**
   * Optional Icon to be displayed in profile link.
   */
  icon: _propTypes2.default.element,
  /**
   *  Specifies where to open the linked document.
   */
  target: _propTypes2.default.string,
  /**
   * Whether or not the link should be styled as active or not.
   */
  isActive: _propTypes2.default.bool,
  /**
   * Whether or not the link is external.
   */
  isExternal: _propTypes2.default.bool,
  /**
   * An optional badge. When supplied, displays the value inline, styled alongside the text.
   */
  badgeValue: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string])
};

var navItemShapeDefaults = exports.navItemShapeDefaults = {
  url: '',
  icon: null,
  target: '_self',
  isActive: false,
  badgeValue: 0
};