'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _bind = require('classnames/bind');

var _bind2 = _interopRequireDefault(_bind);

var _terraArrange = require('terra-arrange');

var _terraArrange2 = _interopRequireDefault(_terraArrange);

var _IconOutlineQuestionMark = require('terra-consumer-icon/lib/icon/IconOutlineQuestionMark');

var _IconOutlineQuestionMark2 = _interopRequireDefault(_IconOutlineQuestionMark);

var _reactIntl = require('react-intl');

var _terraResponsiveElement = require('terra-responsive-element');

var _terraResponsiveElement2 = _interopRequireDefault(_terraResponsiveElement);

var _Modal = require('../modal/Modal');

var _Modal2 = _interopRequireDefault(_Modal);

var _NavPropShapes = require('../../NavPropShapes');

var _NavPropShapes2 = _interopRequireDefault(_NavPropShapes);

var _NavHelpContent = require('./NavHelpContent');

var _NavHelpContent2 = _interopRequireDefault(_NavHelpContent);

var _NavHelpPopup = require('./NavHelpPopup');

var _NavHelpPopup2 = _interopRequireDefault(_NavHelpPopup);

var _NavHelp = require('./NavHelp.scss');

var _NavHelp2 = _interopRequireDefault(_NavHelp);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var cx = _bind2.default.bind(_NavHelp2.default);

var propTypes = {
  /**
   * An array of items to be displayed as help menu/popup.
   */
  helpNavs: _propTypes2.default.arrayOf(_propTypes2.default.shape(_NavPropShapes2.default, {
    children: _propTypes2.default.arrayOf(_propTypes2.default.shape(_NavPropShapes2.default, {
      children: _propTypes2.default.array
    }))
  })),
  /**
   * A unique id set to the help button that will be referred in help menu/popup .
   */
  id: _propTypes2.default.string,
  /**
   * Injected react-intl formatting api
   */
  intl: _reactIntl.intlShape.isRequired
};

var defaultProps = {
  id: 'terra-consumer-nav-help-button',
  helpNavs: []
};

var NavHelp = function (_React$Component) {
  _inherits(NavHelp, _React$Component);

  function NavHelp() {
    _classCallCheck(this, NavHelp);

    var _this = _possibleConstructorReturn(this, (NavHelp.__proto__ || Object.getPrototypeOf(NavHelp)).call(this));

    _this.state = {
      isOpen: false
    };

    _this.togglePopup = _this.togglePopup.bind(_this);
    return _this;
  }

  _createClass(NavHelp, [{
    key: 'togglePopup',
    value: function togglePopup() {
      this.setState({
        isOpen: !this.state.isOpen
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          helpNavs = _props.helpNavs,
          id = _props.id,
          intl = _props.intl,
          customProps = _objectWithoutProperties(_props, ['helpNavs', 'id', 'intl']);

      var helpText = intl.formatMessage({ id: 'Terra.Consumer.NavHelp.help' });
      var helpButton = _react2.default.createElement(
        'button',
        {
          id: id,
          onClick: this.togglePopup,
          className: cx('nav-help')
        },
        _react2.default.createElement(_terraArrange2.default, {
          fill: _react2.default.createElement(_IconOutlineQuestionMark2.default, null),
          fitEnd: _react2.default.createElement(
            'div',
            { className: cx('button-text-padding') },
            helpText
          ),
          align: 'stretch'
        })
      );

      var popupContent = _react2.default.createElement(_NavHelpContent2.default, { helpContent: helpNavs, onLinkClick: this.togglePopup });

      var defaultElement = _react2.default.createElement(
        _Modal2.default,
        {
          isModalOpen: this.state.isOpen,
          title: helpText,
          onRequestClose: this.togglePopup
        },
        popupContent
      );

      var popup = _react2.default.createElement(_NavHelpPopup2.default, {
        title: helpText,
        hasHeader: true,
        isOpen: this.state.isOpen,
        targetRef: function targetRef() {
          return document.getElementById(id);
        },
        closePopup: this.togglePopup,
        contentWidth: '320',
        contentHeight: '240',
        classNameContent: cx('popup-content'),
        contentAttachment: 'middle center',
        popupContent: popupContent,
        rowCount: helpNavs.length
      });

      return _react2.default.createElement(
        'div',
        customProps,
        _react2.default.createElement(_terraResponsiveElement2.default, { responsiveTo: 'window', defaultElement: defaultElement, medium: popup }),
        helpButton
      );
    }
  }]);

  return NavHelp;
}(_react2.default.Component);

NavHelp.propTypes = propTypes;
NavHelp.defaultProps = defaultProps;

exports.default = (0, _reactIntl.injectIntl)(NavHelp);