'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _terraArrange = require('terra-arrange');

var _terraArrange2 = _interopRequireDefault(_terraArrange);

var _bind = require('classnames/bind');

var _bind2 = _interopRequireDefault(_bind);

var _IconChevronDown = require('terra-icon/lib/icon/IconChevronDown');

var _IconChevronDown2 = _interopRequireDefault(_IconChevronDown);

var _IconChevronUp = require('terra-icon/lib/icon/IconChevronUp');

var _IconChevronUp2 = _interopRequireDefault(_IconChevronUp);

var _terraToggle = require('terra-toggle');

var _terraToggle2 = _interopRequireDefault(_terraToggle);

var _SafeHtml = require('../safe-html/SafeHtml');

var _SafeHtml2 = _interopRequireDefault(_SafeHtml);

var _SmartLink = require('../smart-link/SmartLink');

var _SmartLink2 = _interopRequireDefault(_SmartLink);

var _NavHelp = require('./NavHelp.scss');

var _NavHelp2 = _interopRequireDefault(_NavHelp);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var cx = _bind2.default.bind(_NavHelp2.default);

var propTypes = {
  helpContent: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    text: _propTypes2.default.string.isRequired,
    children: _propTypes2.default.array,
    url: _propTypes2.default.string,
    isExternal: _propTypes2.default.bool,
    target: _propTypes2.default.string
  })).isRequired,
  onLinkClick: _propTypes2.default.func.isRequired
};

var NavHelpContent = function (_React$Component) {
  _inherits(NavHelpContent, _React$Component);

  function NavHelpContent() {
    _classCallCheck(this, NavHelpContent);

    var _this = _possibleConstructorReturn(this, (NavHelpContent.__proto__ || Object.getPrototypeOf(NavHelpContent)).call(this));

    _this.state = { togglers: {} };

    _this.handleToggle = _this.handleToggle.bind(_this);
    return _this;
  }

  _createClass(NavHelpContent, [{
    key: 'handleToggle',
    value: function handleToggle(toggleIndex) {
      this.setState({
        togglers: _extends({}, this.state.togglers, _defineProperty({}, toggleIndex, !this.state.togglers[toggleIndex]))
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          helpContent = _props.helpContent,
          onLinkClick = _props.onLinkClick;


      var contentList = helpContent.map(function (content, index) {
        var contentElement = void 0;
        var isOpen = _this2.state.togglers[index];
        var toggleIcon = isOpen ? _react2.default.createElement(_IconChevronUp2.default, null) : _react2.default.createElement(_IconChevronDown2.default, null);

        if (content.children && content.children.length > 0) {
          contentElement = _react2.default.createElement(
            'div',
            {
              className: cx('help-item-wrapper'),
              key: content.text
            },
            _react2.default.createElement(
              'button',
              {
                className: cx('help-item', { 'toggler-open': isOpen }),
                onClick: function onClick() {
                  return _this2.handleToggle(index);
                }
              },
              _react2.default.createElement(_terraArrange2.default, {
                className: cx('help-item-text'),
                align: 'stretch',
                fitStart: _react2.default.createElement(
                  'div',
                  { className: cx('icon-text-padding') },
                  content.icon
                ),
                fill: _react2.default.createElement(
                  'div',
                  null,
                  _react2.default.createElement(_SafeHtml2.default, { text: content.text })
                ),
                fitEnd: _react2.default.createElement(
                  'div',
                  null,
                  toggleIcon
                )
              })
            ),
            _react2.default.createElement(
              _terraToggle2.default,
              { isOpen: isOpen, isAnimated: false, className: cx('toggler-padding') },
              content.children.map(function (element) {
                return _react2.default.createElement(
                  'p',
                  { key: element.text, className: cx('toggler-content-alignment') },
                  _react2.default.createElement(
                    'span',
                    { className: cx('help-subitem') },
                    _react2.default.createElement(_SafeHtml2.default, { text: element.text })
                  )
                );
              })
            )
          );
        } else {
          contentElement = _react2.default.createElement(
            _SmartLink2.default,
            {
              className: cx('help-item'),
              key: content.text,
              url: content.url,
              target: content.target,
              isExternal: content.isExternal,
              handleClick: onLinkClick
            },
            _react2.default.createElement(_terraArrange2.default, {
              className: cx('help-item-text'),
              align: 'center',
              fitStart: _react2.default.createElement(
                'div',
                { className: cx('icon-text-padding') },
                content.icon
              ),
              fill: _react2.default.createElement(
                'div',
                null,
                _react2.default.createElement(_SafeHtml2.default, { text: content.text })
              )
            })
          );
        }
        return contentElement;
      });

      return _react2.default.createElement(
        'div',
        null,
        contentList
      );
    }
  }]);

  return NavHelpContent;
}(_react2.default.Component);

NavHelpContent.propTypes = propTypes;

exports.default = NavHelpContent;