'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _bind = require('classnames/bind');

var _bind2 = _interopRequireDefault(_bind);

var _NavItem = require('./NavItem');

var _NavItem2 = _interopRequireDefault(_NavItem);

var _NavPropShapes = require('../../NavPropShapes');

var _NavPropShapes2 = _interopRequireDefault(_NavPropShapes);

var _NavItem3 = require('./NavItem.scss');

var _NavItem4 = _interopRequireDefault(_NavItem3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var cx = _bind2.default.bind(_NavItem4.default);

var propTypes = {
  navItems: _propTypes2.default.arrayOf(_propTypes2.default.shape(_NavPropShapes2.default, {
    /**
     * An optional array of objects to be displayed as sub navs toggled by the main nav.
     */
    subItems: _propTypes2.default.arrayOf(_propTypes2.default.shape(_NavPropShapes2.default))
  })),

  /**
   * Function to be applied on all nav links, excluding toggle headers.
   */
  handleClick: _propTypes2.default.func
};

var defaultProps = {
  navItems: []
};

/**
 * Returns the index of Navitems for an isActive subItem.
 * @param  {object[]} navItems - An array of objects displayed as nav link options.
 * @param  {number} - The index.
 */
var findNavItemsIndex = function findNavItemsIndex(navItems) {
  return navItems.findIndex(function (item) {
    return item.subItems && item.subItems.some(function (subItem) {
      return subItem.isActive;
    });
  });
};

var NavItems = function (_Component) {
  _inherits(NavItems, _Component);

  function NavItems(props) {
    _classCallCheck(this, NavItems);

    var _this = _possibleConstructorReturn(this, (NavItems.__proto__ || Object.getPrototypeOf(NavItems)).call(this, props));

    var initialIndex = findNavItemsIndex(props.navItems);

    _this.state = {
      openToggle: initialIndex
    };

    _this.handleToggle = _this.handleToggle.bind(_this);
    return _this;
  }

  _createClass(NavItems, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var index = findNavItemsIndex(nextProps.navItems);

      if (findNavItemsIndex(this.props.navItems) === index) {
        return;
      }

      this.setState({
        openToggle: index
      });
    }
  }, {
    key: 'handleToggle',
    value: function handleToggle(toggleId, isOpen) {
      this.setState({
        openToggle: isOpen ? toggleId : null
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          navItems = _props.navItems,
          handleClick = _props.handleClick,
          customProps = _objectWithoutProperties(_props, ['navItems', 'handleClick']);

      var content = navItems.map(function (element, i) {
        var toggleProps = {};
        var subNavs = [];
        if (element.subItems) {
          // eslint-disable-next-line react/no-array-index-key
          subNavs = element.subItems.map(function (item, index) {
            return _react2.default.createElement(_NavItem2.default, _extends({ key: index }, item, { handleClick: handleClick }));
          });
          toggleProps = {
            isOpen: _this2.state.openToggle === i,
            handleToggle: _this2.handleToggle,
            toggleId: i
          };
        }

        return _react2.default.createElement(
          _NavItem2.default,
          _extends({
            key: element.text,
            url: element.url,
            text: element.text,
            icon: element.icon,
            target: element.target,
            isActive: element.isActive,
            isExternal: element.isExternal,
            badgeValue: element.badgeValue,
            handleClick: handleClick
          }, toggleProps),
          subNavs
        );
      });

      return _react2.default.createElement(
        'div',
        _extends({}, customProps, { className: cx(customProps.className) }),
        content
      );
    }
  }]);

  return NavItems;
}(_react.Component);

NavItems.propTypes = propTypes;
NavItems.defaultProps = defaultProps;

exports.default = NavItems;