'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _bind = require('classnames/bind');

var _bind2 = _interopRequireDefault(_bind);

var _terraArrange = require('terra-arrange');

var _terraArrange2 = _interopRequireDefault(_terraArrange);

var _IconChevronDown = require('terra-icon/lib/icon/IconChevronDown');

var _IconChevronDown2 = _interopRequireDefault(_IconChevronDown);

var _IconChevronUp = require('terra-icon/lib/icon/IconChevronUp');

var _IconChevronUp2 = _interopRequireDefault(_IconChevronUp);

var _terraToggle = require('terra-toggle');

var _terraToggle2 = _interopRequireDefault(_terraToggle);

var _NavPropShapes = require('../../NavPropShapes');

var _NavPropShapes2 = _interopRequireDefault(_NavPropShapes);

var _SafeHtml = require('../safe-html/SafeHtml');

var _SafeHtml2 = _interopRequireDefault(_SafeHtml);

var _ProfileLink = require('./ProfileLink');

var _ProfileLink2 = _interopRequireDefault(_ProfileLink);

var _UserProfile = require('./UserProfile.scss');

var _UserProfile2 = _interopRequireDefault(_UserProfile);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var cx = _bind2.default.bind(_UserProfile2.default);

var propTypes = {
  /**
   * An array of nav items to be displayed on the user profile/ settings menu/popup.
   */
  linkItems: _propTypes2.default.arrayOf(_propTypes2.default.shape(_NavPropShapes2.default, {
    subItems: _propTypes2.default.arrayOf(_propTypes2.default.shape(_NavPropShapes2.default))
  })),

  /**
   * An optional function. When supplied, gets triggered on link click.
   */
  handleClick: _propTypes2.default.func
};

var defaultProps = {
  linkItems: []
};

var ProfileLinks = function (_React$Component) {
  _inherits(ProfileLinks, _React$Component);

  function ProfileLinks() {
    _classCallCheck(this, ProfileLinks);

    var _this = _possibleConstructorReturn(this, (ProfileLinks.__proto__ || Object.getPrototypeOf(ProfileLinks)).call(this));

    _this.state = { togglers: {} };

    _this.handleToggle = _this.handleToggle.bind(_this);
    return _this;
  }

  _createClass(ProfileLinks, [{
    key: 'handleToggle',
    value: function handleToggle(toggleIndex) {
      this.setState({
        togglers: _extends({}, this.state.togglers, _defineProperty({}, toggleIndex, !this.state.togglers[toggleIndex]))
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          linkItems = _props.linkItems,
          handleClick = _props.handleClick,
          customProps = _objectWithoutProperties(_props, ['linkItems', 'handleClick']);

      var profileLinks = linkItems.map(function (linkItem, index) {
        if (linkItem.subItems && linkItem.subItems.length > 0) {
          var isOpen = _this2.state.togglers[index];
          var toggleIcon = isOpen ? _react2.default.createElement(_IconChevronUp2.default, null) : _react2.default.createElement(_IconChevronDown2.default, null);
          return _react2.default.createElement(
            'div',
            { key: linkItem.text, className: cx(isOpen && 'open') },
            _react2.default.createElement(
              'button',
              { onClick: function onClick() {
                  _this2.handleToggle(index);
                }, className: cx('link', 'toggler-wrapper') },
              _react2.default.createElement(_terraArrange2.default, {
                align: 'stretch',
                fill: _react2.default.createElement(_SafeHtml2.default, { text: linkItem.text }),
                fitEnd: _react2.default.createElement(
                  'div',
                  null,
                  toggleIcon
                )
              })
            ),
            _react2.default.createElement(
              _terraToggle2.default,
              { isOpen: isOpen, isAnimated: false, className: cx('toggler') },
              linkItem.subItems.map(function (subItem) {
                return _react2.default.createElement(_ProfileLink2.default, _extends({ key: subItem.text }, subItem, { handleClick: handleClick }));
              })
            )
          );
        }
        return _react2.default.createElement(_ProfileLink2.default, {
          key: linkItem.text,
          url: linkItem.url,
          text: linkItem.text,
          target: linkItem.target,
          isExternal: linkItem.isExternal,
          handleClick: handleClick
        });
      });

      return _react2.default.createElement(
        'div',
        customProps,
        profileLinks
      );
    }
  }]);

  return ProfileLinks;
}(_react2.default.Component);

ProfileLinks.propTypes = propTypes;
ProfileLinks.defaultProps = defaultProps;

exports.default = ProfileLinks;